; 
;   Copyright 1994-2003 Free Software Foundation, Inc.
;
;   This library is free software; you can redistribute it and/or
;   modify it under the terms of the GNU Lesser General Public
;   License as published by the Free Software Foundation; either
;   version 2.1 of the License, or (at your option) any later version.
;
;   This library is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;   Lesser General Public License for more details.
;
;   You should have received a copy of the GNU Lesser General Public
;   License along with this library; if not, write to the Free Software
;   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
;   USA
;
;   You may contact the author at:
;
;   mailto::camille@bluegrass.net
;
;   or by snail mail at:
;
;   David Lindauer
;   850 Washburn Ave Apt 99
;   Louisville, KY 40222
;
; MOVE.ASM
;
; Function: move memory regions
;
	;MASM MODE
	.386
	.MODEL SMALL


include  prints.ase 
include  input.ase 
include  mtrap.ase 

	PUBLIC move


	.CODE
;
; move command
;
move	PROC
	call	WadeSpace
	jz	errx
	call	ReadAddress 			; read source
	jc	errx
	call	WadeSpace
	jz	errx
	call	ReadNumber		; read end of source
	jc	errx
	mov	ecx,eax
	sub	ecx,ebx
	jb	errx
	call	WadeSpace
	jz	errx
	mov	edx,ebx
	call	ReadAddress			; read dest
	jc	errx
	call	WadeSpace
	jnz	errx
	mov	edi,ebx
	mov	esi,edx
	cmp	esi,edi
	jz	noop
	jl	sld
sgd:
	rep	movsb
	jmp	noop
sld:
	lea	esi,[esi+ecx-1]
	lea	edi,[edi+ecx-1]
	std
	rep	movsb
	cld
noop:
	clc				; to clean up stack
	ret
errx:
	stc
	ret
move	endp
end